try:
    from osgeo import ogr
except ImportError:
    import ogr

from importer import Importer
import utils

NAME="Axis"
TABLE_NAME="river_axes"
PATH="Geodaesie/Flussachse+km"


class Axis(Importer):

    def getPath(self, base):
        return "%s/%s" % (base, PATH)


    def getTablename(self):
        return TABLE_NAME


    def getName(self):
        return NAME


    def isGeometryValid(self, geomType):
        return geomType in [ogr.wkbLineString,
                            ogr.wkbLineString25D,
                            ogr.wkbMultiLineString25D,
                            ogr.wkbMultiLineString]

    def isShapeRelevant(self, name, path):
        return "achse" in name.lower()


    def createNewFeature(self, featureDef, feat, **args):
        newFeat = ogr.Feature(featureDef)
        newFeat.SetGeometry(feat.GetGeometryRef())
        newFeat.SetField("name", args['name'])

        if self.IsFieldSet(feat, "river_id"):
            riverId = feat.GetField("river_id")
        else:
            riverId = self.river_id

        if self.IsFieldSet(feat, "kind"):
            kind = feat.GetField("kind")
        else:
            kind = 0

        newFeat.SetField("river_id", riverId)
        newFeat.SetField("kind", kind)

        return utils.convertToMultiLine(newFeat)
